package eGuideDog::Terminal::Buffer;

use strict;
use warnings;

sub new {
  my ($class, $buffer) = @_;

  $buffer = [] if (!ref $buffer);

  my $self = {id => undef,
	      update => 1,
	      lines => $buffer,
	      index => 0,
	      head => 0,
	     };

  bless $self, __PACKAGE__;
  return $self;
}

sub update {
  my ($self, $update) = @_;
  $self->{update} = $update if (defined $update);
  return $self->{update};
}

sub current_line {
  my ($self, $value) = @_;

  if (defined $value) {
    $self->{lines}->[$self->{index}] = $value;
  } else {
    return $self->{lines}->[$self->{index}];
  }
}

sub lines {
  my ($self, $lines) = @_;
  $self->{lines} = $lines if (defined $lines);
  return $self->{lines};
}

sub index {
  my ($self, $index) = @_;
  $self->{index} = $index if (defined $index);
  $self->{update} = 1;
  return $self->{index};
}

1;
